<?php
/**
*********************
*     SENDEMAIL     *
*********************
*
* Version 1.0 - (2010/04/24)
*
* This script is used to provide a mailform and send the mail
*
* SOFTWARE LICENSE: GPL
* (C) 2010 Hans-Georg Bork
*
* This script is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License 
* as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
* 
* This script is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
* 
* You should have received a copy of the GNU Lesser General Public
* License along with this script; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*
* written by Hans-Georg Bork (hgb@users.sourceforge.net)
*/

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  Deze constructie zet een onderwerp en hecht daar een emailadres aan
  Iedere regel moet dan zo uitzien (verander niets aan de andere regels;
  de laatste regel mag geen komma aan het einde hebben!)
  
  	"onderwerp" => "emailadres",
  	
  Dit wordt gebruikt om ieder onderwerp naar een eigen emailadres
  te sturen en niet altijd aan dezelfde.
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

$onderwerpadres = array(

	"I want to send you my compliments for this nice form" => "hgb@users.sourceforge.net",
	"You removed the compliment text? Type here a different one ..." => "you@your_provider.com",
	"... and many more if you like ..." => "email@example.net",

	"This last line may not end with a komma ','" => "email@example.org"
);

// Veranderingen vanaf hier zijn niet op mijn lasten :)
// Changes below this line are not my fault :)

$copyright="\n\nSendEmail.php 1.0 (C) 2010 Hans-Georg Bork (hgb@users.sourceforge.net)\n\nDownload this from http://hgbhome.net/software/sendemail.tar.gz";
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  This is a fix if register_globals is turned off
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
if(!$PHP_SELF){
	if($_POST) 	{extract($_POST, EXTR_PREFIX_SAME, "post_");}
	if($_GET)  	{extract($_GET, EXTR_PREFIX_SAME, "get_");}
	if($_COOKIE)	{extract($_COOKIE, EXTR_PREFIX_SAME, "cookie_");}
	if($_ENV)	{extract($_ENV, EXTR_PREFIX_SAME, "env_");}
}
if($PHP_SELF == ""){ $PHP_SELF = $_SERVER['PHP_SELF']; } 


$ip = getenv("REMOTE_ADDR");
$httpagent  = getenv("HTTP_USER_AGENT");
$httpref = getenv("HTTP_REFERER");

// check fields

function field_errors( $naam, $adres, $bericht) {
	$naamfout = false;
	$adresfout = false;
	$berichtfout = false;
	$fieldfout = false;
	
	if( strlen($naam) <= 3 ) { $naamfout = true; } 
	if( strlen($adres) <= 6 || !strstr($adres,"@") || !strstr($adres,".")) { $adresfout = true; } 
	if( strlen($bericht) <= 3 ) { $berichtfout = true; }
	
	foreach( $_REQUEST as $fields => $value ) {
		if( eregi("TO:", $value) || eregi("CC:", $value) || eregi("CCO:", $value) || eregi("BCC:", $value) || eregi("Content-Type", $value) ) {
			$fieldfout = true;
		} // if( eregi ...
	} // foreach
	
	if( $naamfout || $adresfout || $berichtfout || $fieldfout ) {
		print "<h2 align=\"center\">Er is een fout opgetreden</h2>";
		
		if( $naamfout ) print "<p>Your name is too short.</p>"; 
		if( $adresfout ) print "<p>Your emailadress is wrong.</p>"; 
		if( $berichtfout ) print "<p>Your message is too short.</p>";
		if( $fieldfout ) print "<p>ERROR: Code injection attempt denied!<br />
					Don't try to use 'TO:', 'CC:', 'CCO:', 'BCC:' of 'Content-Type' in this form.</p>";
		
		print "<form method=\"post\" action=\"$PHP_SELF\">";
		print "		<p align=\"center\"><input type=\"button\" value=\"Terug\" onClick=\"history.back();\" /></p>";
		print "</form><hr /><br />";
		
		return true;
	} // if( $naamfout || ...
	
	return false;
} // field_errors()

// avoid wrong calls
$defaultaction = FALSE;
if( !isset( $action ) || ($action != "view" && $action != "send" )) {
	$defaultaction = TRUE;
}

if( $defaultaction ) {
	unset( $action ); // to be able to use it in form
	$onderwerpoptions = "";
	foreach( $onderwerpadres as $onderwerp => $emailadres ) {
		$onderwerpoptions .= "<option value=\"$onderwerp\">$onderwerp</option>\n";
	}
	
	print <<<HTML
		<h2 align="center">Mailform</h2>
		<p align="center">
		<form method="post" action="$PHP_SELF">
		<table border="0" cellpadding="2" cellspacing="4">
		  <tr>
			<td align="right">Name:</td>
			<td><input type="text" name="naam" size="35" /></td>
		  </tr>
		  <tr>
			<td align="right">Emailadress:</td>
			<td><input type="text" name="adres" size="35" /></td>
		  </tr>
		  <tr>
			<td align="right">Subject:</td>
			<td>
				<select name="onderwerp" size="1">
					$onderwerpoptions
				</select>
			</td>
		  </tr>
		  <tr>
			<td align="right">Message:</td>
			<td><textarea name="bericht" rows="6" cols="40" wrap="soft"></textarea></td>
		  </tr>
		  <tr>
			<td align="right">Want a copy of this?</td>
			<td>&nbsp;&nbsp;No <input name="ccopy" type="radio" value="ccnee" />&nbsp;&nbsp;Yes <input checked="checked" name="ccopy" type="radio" value="ccja" /></td>
		  </tr>
		  <tr>
			<td align="right"> </td>
			<td><input type="submit" value="Preview" /></td>
		  </tr>
		</table>

			<input type="hidden" name="action" value="view" />
			
			<!--	BIG BROTHER IS WATCHING YOU	-->
			<input type="hidden" name="ip" value=$ip />
			<input type="hidden" name="httpref" value=$httpref />
			<input type="hidden" name="httpagent" value=$httpagent />
	
		</form>
		<br><br><br>$copyright
	</p>
	
HTML;
} // if( $defaultaction )

if( $action == "view" && !field_errors( $naam, $adres, $bericht ) ) {
	$txtccopy = (($ccopy == "ccja") ? "" : "don't");

	print <<<HTML
		<h2 align="center">Preview of your email</h2>
		<p align="center">
		<form method="post" action="$PHP_SELF">
		<table border="0" cellpadding="2" cellspacing="4">
		  <tr>
			<td align="right">Name:</td>
			<td><input type="text" name="naam" size="35" value="$naam" readonly /></td>
		  </tr>
		  <tr>
			<td align="right">Emailadress:</td>
			<td><input type="text" name="adres" size="35" value="$adres" readonly /></td>
		  </tr>
		  <tr>
			<td align="right">Subject:</td>
			<td><input type="text" name="onderwerp" size="35" value="$onderwerp" readonly /></td>
			
		  </tr>
		  <tr>
			<td align="right">Message:</td>
			<td><textarea name="bericht" rows="6" cols="40" wrap="soft" readonly>$bericht</textarea></td>
		  </tr>
		  <tr>
		  	<td align="right"> </td>
		  	<td>You $txtccopy want a copy of this mail.</td>
		  </tr>
		  <tr>
			<td align="right"><input type="submit" value="Submit" /></td>
			<td><input type="button" value="Terug" onClick="history.back();" /></td>
		  </tr>
		</table>

			<input type="hidden" name="ccopy" value=$ccopy />
			<input type="hidden" name="action" value="send" />
			
			<!--	BIG BROTHER IS WATCHING YOU	-->
			<input type="hidden" name="ip" value=$ip />
			<input type="hidden" name="httpref" value=$httpref />
			<input type="hidden" name="httpagent" value=$httpagent />
		</form>
		<br><br><br>$copyright
		<p align="center">

HTML;

} // if( $action == "view" ) 

if( $action == "send" ) {

	$emailheader = "From: mailform@hgbhome.net\r\n";
	$emailheader = $emailheader . "Reply-To: " . $adres . "\r\n";

	$emailto = $onderwerpadres[$onderwerp];
	
	$emailsubject = $onderwerp;
	
	$emailmessage = "Mailform on $httpref\n\n";
	$emailmessage .= "Name : " . $naam . "\nEmailadress : " . $adres . "\nSubject : " . $onderwerp . "\n";
	$emailmessage .= "Message :\n" . $bericht . "\n";
	
	$emailsuccessadres = TRUE;
	if( $ccopy == "ccja" ) { $emailsuccessadres = mail( $adres, $emailsubject, $emailmessage . $copyright, $emailheader ); }

	$emailmessage .= "\nFurther information:\nIP-adres: " . $ip . "\nBrowser: " . $httpagent . "\n";
	
	$emailsuccessto = mail( $emailto, $emailsubject, $emailmessage . $copyright, $emailheader );
	
	if( $emailsuccessto && $emailsuccessadres ) {
		print "<h2 align=\"center\">Your email is submitted</h2>";
		print "<p align=\"center\"><a href=\"$path/\"><input type=\"button\" value=\"Back to main site\" /></a></p>";
	} else {
		print "<h2 align=\"center\">An error occured.<br />Your email is not submitted.</h2>";
		print "<p align=\"center\"><a href=\"$path/\"><input type=\"button\" value=\"Previous page\" onClick=\"history.back();\" /></a></p>";
	} // if( mail( ...
	print "<br><br><br><p align=\"center\">$copyright</p>";

} // if( $action == "send" )
?>
